﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Reflection.Emit;
using Omix.Dynamic.Data;
using Omix.Dynamic.Common;
using System.Data.Entity;

namespace Dynamix.Test
{
    public partial class FrmMain : Form
    {
        Omix.Dynamic.Data.Database db = null;

        public FrmMain()
        {
            InitializeComponent();
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            try
            {
                btnConnect.Text = "Connecting";
                btnConnect.Enabled = false;

                //Main Code
                db = new Omix.Dynamic.Data.Database(txtConnectionString.Text);
                db.Config.Asynchronized = true;
                db.Config.BrowsePrimaryKeyColumns = true;
                db.Config.BrowseForeignKeyColumns = true;
                db.OnFinishedLoading += new FinishedLoading(db_OnFinishedLoading);
                db.Load();


            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }

        void db_OnFinishedLoading()
        {
            if (db.IsActive)
            {
                btnConnect.Text = "Connected";
                lstTables.DataSource = db.Schema.Tables.ToList();
                grb.Visible = true;
            }
            else
            {
                btnConnect.Text = "Connect";
                btnConnect.Enabled = true;
            }
        }

        private void lstTables_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Binding Columns
            lstColumns.DataSource = ((TableInfo)lstTables.SelectedItem).Columns;

            //Bindign Grid
            try
            {
                var List = db.Get(lstTables.SelectedItem.ToString());
                //DbExtensions.Load(List);
                dataGridView1.DataSource = (List as IEnumerable<dynamic>).ToList();
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }

        private void lstColumns_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Binding Column Info
            pgColumnInfo.SelectedObject = lstColumns.SelectedItem;
        }

        
    }
}
